/*
 * This Java source file is completely Free and Open-Source, 
 * released under the MIT License.
 *
 * Copyright (2012) Ashish Nawal Saharia (ashish.saharia@yahoo.co.in)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
 * OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 */

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package net.infantai.nlp.ner;

import net.infantai.util.common.DateParts;
import net.infantai.util.common.TokenGroup;

/**
 *
 * @author Ashish (ashish.saharia@yahoo.co.in)
 */
public class EntityTaggerOutput implements Comparable<EntityTaggerOutput>
{
    public TokenGroup tg = null;
    public EntityKeyword ek = new EntityKeyword();
    public boolean isDictionaryMatch = false;
    public DateParts entityDateParts = null;
    public String entityType = "";
    public double confidenceScore = 0.98F;
    public TokenGroup tgNegation = null;
    public String possibleValue = null;
    public int possibleValueIndex = -1;

    @Override
    public int compareTo(EntityTaggerOutput o)
    {
        return this.tg.getIndex() - o.tg.getIndex();
    }
    
    @Override
    public String toString()
    {
        return tg.getToken() + ", index: " + tg.getIndex();
    }
    
}
