/*
 * This Java source file is completely Free and Open-Source, 
 * released under the MIT License.
 *
 * Copyright (2012) Ashish Nawal Saharia (ashish.saharia@yahoo.co.in)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
 * OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 */

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package net.infantai.util.common;

import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;

/**
 *
 * @author Ashish (ashish.saharia@yahoo.co.in)
 */
public class HTMLUtil
{
    
    private Map<String, String> javaRegexUnicodeStringReplacement = new LinkedHashMap<>();
    
    public HTMLUtil()
    {
        // Should consider initializing this Map from a config file.
        javaRegexUnicodeStringReplacement.put("\u00A0", " ");
        javaRegexUnicodeStringReplacement.put("\u2000", " ");
        javaRegexUnicodeStringReplacement.put("\u2001", " ");
        javaRegexUnicodeStringReplacement.put("\u2002", " ");
        javaRegexUnicodeStringReplacement.put("\u2003", " ");
        javaRegexUnicodeStringReplacement.put("\u2004", " ");
        javaRegexUnicodeStringReplacement.put("\u2005", " ");
        javaRegexUnicodeStringReplacement.put("\u2006", " ");
        javaRegexUnicodeStringReplacement.put("\u2007", " ");
        javaRegexUnicodeStringReplacement.put("\u2008", " ");
        javaRegexUnicodeStringReplacement.put("\u2009", " ");
        javaRegexUnicodeStringReplacement.put("\u200A", " ");
        javaRegexUnicodeStringReplacement.put("\u200B", " ");
        javaRegexUnicodeStringReplacement.put("\u202F", " ");
        javaRegexUnicodeStringReplacement.put("\u205F", " "); // MEDIUM MATHEMATICAL SPACE
        javaRegexUnicodeStringReplacement.put("\u2028", " "); // LINE SEPARATOR
        javaRegexUnicodeStringReplacement.put("\u2029", " "); // PARAGRAPH SEPARATOR

        javaRegexUnicodeStringReplacement.put("\u2010", "-");
        javaRegexUnicodeStringReplacement.put("\u2011", "-");
        javaRegexUnicodeStringReplacement.put("\u2012", "-");
        javaRegexUnicodeStringReplacement.put("\u2013", "-");
        javaRegexUnicodeStringReplacement.put("\u2014", "-");
        
        javaRegexUnicodeStringReplacement.put("\u2018", "'"); // LEFT SINGLE QUOTATION MARK
        javaRegexUnicodeStringReplacement.put("\u2019", "'"); // RIGHT SINGLE QUOTATION MARK
        javaRegexUnicodeStringReplacement.put("\u201C", "\""); // LEFT DOUBLE QUOTATION MARK
        javaRegexUnicodeStringReplacement.put("\u201D", "\""); // RIGHT DOUBLE QUOTATION MARK
        
        javaRegexUnicodeStringReplacement.put("\u2024", ".");
        javaRegexUnicodeStringReplacement.put("\u2025", "..");
        javaRegexUnicodeStringReplacement.put("\u2026", "..."); // HORIZONTAL ELLIPSIS
    }
    
    public String replaceCommonUnicodeCharactersWithASCIICharacters(String input)
    {
        String cleanedString = input;
        Iterator<Map.Entry<String, String>> iterRegexUnicode = javaRegexUnicodeStringReplacement.entrySet().iterator();
        while (iterRegexUnicode.hasNext())
        {
            Map.Entry<String, String> mapEntry = iterRegexUnicode.next();
            String javaRegexUnicodeString = mapEntry.getKey();
            String replacement = mapEntry.getValue();
            cleanedString = cleanedString.replaceAll(javaRegexUnicodeString, replacement);
        }
        return cleanedString.replaceAll("\\s+", " ").trim();
    }
    
    
    public static void main(String[] args)
    {
        HTMLUtil hutil = new HTMLUtil();
        String input = "ganga conversation  ";
        System.out.println("input length: " + input.length() + "=>" + input + "**");
        String output = hutil.replaceCommonUnicodeCharactersWithASCIICharacters(input);
        System.out.println("output length: " + output.length() + "=>" + output + "**");
    }
    
}
