/*
 * This Java source file is completely Free and Open-Source, 
 * released under the MIT License.
 *
 * Copyright (2012) Ashish Nawal Saharia (ashish.saharia@yahoo.co.in)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
 * OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 */

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.infantai.util.common;

/**
 *
 * @author Ashish (ashish.saharia@yahoo.co.in)
 */
public class TokenGroup implements Comparable<TokenGroup>
{
    private String token = "";
    private Integer index = null;
    private Integer size = null;

    public TokenGroup(String token, int tokenIndex, int tokenSize)
    {
        this.token = token;
        this.index = new Integer(tokenIndex);
        this.size = new Integer(tokenSize);
    }

    public TokenGroup(String token, Integer tokenIndex, Integer tokenSize)
    {
        this.token = token;
        this.index = tokenIndex;
        this.size = tokenSize;
    }

    public Integer getIndex()
    {
        return index;
    }

    public void setIndex(Integer tokenIndex)
    {
        this.index = tokenIndex;
    }

    public Integer getSize()
    {
        return size;
    }

    public void setSize(Integer tokenSize)
    {
        this.size = tokenSize;
    }

    public String getToken()
    {
        return token;
    }

    public void setToken(String token)
    {
        this.token = token;
    }

    @Override
    public boolean equals(Object obj)
    {
        if (obj != null && obj instanceof TokenGroup)
        {
            TokenGroup tg = (TokenGroup) obj;
            if (this.getToken().equals(tg.getToken()) && this.getIndex().intValue() == tg.getIndex().intValue())
            {
                return true;
            }        
        }
        return false;
    }

    @Override
    public int hashCode()
    {
        return this.getToken().hashCode();
    }

    @Override
    public int compareTo(TokenGroup o1)
    {
        if (this.getToken().equals(o1.getToken()) && this.getIndex().intValue() == o1.getIndex().intValue())
        {
            return 0;
        }
        else if (this.getToken().length() > o1.getToken().length())
        {
            return -1;
        }
        else if (this.getToken().length() == o1.getToken().length() && this.getIndex().intValue() < o1.getIndex().intValue())
        {
            return -1;
        }
        else
        {
            return 1;
        }
    }

    @Override
    public String toString()
    {
        return token;
    }

}
